<script lang="ts">
import Vue from 'vue';
import FeatureList from './feature-list.vue';
import FeaturedAddOnsCard from './featured-add-ons-card.vue';

export default Vue.extend({
  components: {
    FeatureList,
    FeaturedAddOnsCard,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
    isSelfManaged: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
});
</script>

<template>
  <div class="addons__container">
    <SlpTypography variant="heading2-bold" tag="h2"
      >{{ data.heading }}
    </SlpTypography>
    <SlpTypography variant="heading4" tag="h3" class="addons__subtitle"
      >{{ data.text }}
    </SlpTypography>
    <div
      class="addons__card_container addons__row"
      :class="{ 'addons__card_container--is-sm': isSelfManaged }"
    >
      <div
        v-for="card in data.cards"
        :key="card.title"
        size="lg"
        class="addons__col"
      >
        <FeaturedAddOnsCard
          v-if="card.featured"
          :data="card"
          :is-self-managed="isSelfManaged"
        />
        <a
          v-else
          class="addons__card"
          :href="card.link.url"
          :data-ga-name="card.link.data_ga_name"
          :data-ga-location="card.link.data_ga_location"
        >
          <div class="addons__card-brace">
            <SlpPillButton v-if="card.pill" type="true" class="slp-mb-16">
              {{ card.pill }}
            </SlpPillButton>
            <SlpTypography variant="heading2-bold" tag="h2" class="slp-mb-16"
              >{{ card.title }}
            </SlpTypography>
            <SlpTypography
              variant="heading4"
              class="addons__card_heading"
              tag="h3"
              >{{ card.heading }}
            </SlpTypography>
            <div>
              <div class="addons__card_price">
                <SlpTypography variant="heading1-bold" tag="h4"
                  >{{ card.price }}
                </SlpTypography>
                <div class="details">
                  <SlpTypography variant="body2" tag="p"
                    >{{ card.price_info }}
                  </SlpTypography>
                  <SlpTypography variant="body2" tag="p"
                    >{{ card.description }}
                  </SlpTypography>
                </div>
              </div>
            </div>
            <div v-if="card.features?.list" class="slp-mb-24">
              <FeatureList :data="card.features"></FeatureList>
            </div>
            <SlpTypography variant="body2-bold" tag="span" class="addons__link">
              <span> {{ card.link.text }}</span>
              <SlpIcon
                name="chevron-lg-right"
                variant="product"
                slp-color="primary-200"
                alt="Chevron Right Icon"
              />
            </SlpTypography>
          </div>
        </a>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.italicize {
  font-style: italic;
}

.addons {
  &__container {
    background: $color-surface-800;
    border-radius: $border-radius-24;
    margin-bottom: $spacing-96;
    padding: $spacing-32 $spacing-16;

    @media (min-width: $breakpoint-lg) {
      padding: $spacing-96 $spacing-64;
    }
    :deep {
      .pricing-feature-list-container .item {
        margin-bottom: $spacing-16;
        margin-top: 0;
      }
    }
  }

  &__card_container {
    width: 100%;
    &.addons__card_container--is-sm {
      .addons__col {
        &:nth-child(2) {
          grid-row-end: span 2;
          grid-column-end: span 2;
        }
        &:nth-child(3),
        &:nth-child(4) {
          display: none;
        }
      }
    }
  }

  &__subtitle {
    @media (min-width: $breakpoint-lg) {
      width: 60%;
    }
    margin-bottom: 40px;
  }
  &__card-brace {
    display: flex;
    flex-direction: column;
    height: 100%;
  }
  &__card {
    border-radius: 12px;
    display: block;
    padding: $spacing-24;
    background-color: white;
    // margin-bottom: $spacing-24;
    transition: all 0.3s ease-in;
    height: 100%;
    color: $color-text-300;

    &:hover {
      box-shadow: 0 24px 50px -16px #d1d0d3;
    }

    @media (min-width: $breakpoint-lg) {
      width: 100%;
      // width: 440px;
      padding: 40px $spacing-48;
    }

    &_heading {
      margin-bottom: 40px;
      color: $color-text-300;
    }

    &_price {
      display: flex;
      flex-direction: row;
      align-items: center;
      margin-bottom: $spacing-24;
      h1 {
        color: $color-text-300;
      }
      .details {
        margin-left: $spacing-24;
        max-width: inherit;
        word-break: break-word;
        color: $color-text-link-100;
        p {
          font-weight: bold;
        }
      }
    }
    :deep {
      .slp-pill-btn {
        cursor: default;
        padding: 4px 12px;
        .slp-icon {
          display: none;
        }
      }
      .list {
        margin-bottom: 0;
      }
    }
  }

  &__link {
    color: black;
    display: block;
    // padding-right: 20px;
    position: relative;
    padding: $spacing-16 0;
    margin: auto 0 0 0;

    .slp-icon {
      width: 18px;
      height: 20px;
      display: inline-flex;
      position: relative;
      :deep div {
        position: absolute;
        top: 2px;
        left: 0;
      }
    }
    &--hide-on-mobile {
      display: none;
      @media (min-width: $breakpoint-md) {
        display: block;
      }
    }
    &--hide-on-desktop {
      display: block;
      @media (min-width: $breakpoint-md) {
        display: none;
      }
    }
  }
  &__col {
    &:nth-child(1) {
      @media (min-width: $breakpoint-md) {
        grid-row-end: span 2;
        grid-column-end: span 2;
      }
    }
    &:nth-child(2) {
      grid-row-end: span 2;
    }
  }
  &__row {
    display: grid;
    grid-template-columns: 1fr;
    grid-gap: 32px;
    @media (min-width: $breakpoint-md) {
      grid-template-columns: 1fr 1fr;
      grid-gap: 32px;
    }
  }
}
</style>
